#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
#define		__python	/usr/bin/python3
%define		composants	zebra ripd ripngd bgpd staticd vrrpd
#-----------------------------------------------------------------------------
Name		:	frr
Version		:	8.5.2
Release		:	14.4.0.0%{?dist}
Summary		:	Routing Software Suite

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2+
URL		:	https://github.com/FRRouting/frr

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	autoconf
BuildRequires	:	automake
BuildRequires	:	bison
BuildRequires	:	c-ares
BuildRequires	:	flex
BuildRequires	:	gcc
BuildRequires	:	json-c-devel
BuildRequires	:	libtool
BuildRequires	:	libyang-devel
BuildRequires	:	make
BuildRequires	:	ncurses-devel
BuildRequires	:	openssl-devel
BuildRequires	:	patch
BuildRequires	:	python3-sphinx
BuildRequires	:	python3-pytz
BuildRequires	:	readline

BuildRequires	:	python3-docutils

Requires	:	/usr/sbin/useradd, /usr/sbin/userdel
Requires	:	/usr/sbin/groupadd, /usr/sbin/groupdel
Requires	:	lfs-bootscripts
Requires	:	chkconfig
Requires	:	logrotate

conflicts	:	quagga
#-----------------------------------------------------------------------------
%description
FRRouting is free software that manages TCP/IP based routing
protocols. It takes a multi-server and multi-threaded approach
to resolve the current complexity
of the Internet.
 
FRRouting supports BGP4, OSPFv2, OSPFv3, ISIS, RIP, RIPng,
PIM, NHRP, PBR, EIGRP , VRRPD and BFD.
 
FRRouting is a fork of Quagga.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc COPYING README.md
%attr (0754,root,root) %{_sysconfdir}/rc.d/init.d/*
%dir %attr(0755,%{name},%{name}) %{_var}/log/%{name}
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_sysconfdir}/%{name}/*.example.peer1
%{_sysconfdir}/%{name}/*.example.peer2
%{_sysconfdir}/%{name}/*.sample
%{_sysconfdir}/%{name}/scripts/README
%{_bindir}/mtracebis
%{_bindir}/vtysh
%{_sbindir}/babeld
%{_sbindir}/bfdd
%{_sbindir}/bgpd
%{_sbindir}/eigrpd
%{_sbindir}/fabricd
%{_sbindir}/%{name}
%{_sbindir}/%{name}-reload*
%{_sbindir}/%{name}common.sh
%{_sbindir}/%{name}init.sh
%{_sbindir}/%{name}_babeltrace.py
%{_sbindir}/generate_support_bundle.py
%{_sbindir}/isisd
%{_sbindir}/ldpd
%{_sbindir}/nhrpd
%{_sbindir}/ospf6d
%{_sbindir}/ospfd
%{_sbindir}/ospfclient.py
%{_sbindir}/pathd
%{_sbindir}/pimd
%{_sbindir}/pim6d
%{_sbindir}/pbrd
%{_sbindir}/ripd
%{_sbindir}/ripngd
%{_sbindir}/ssd
%{_sbindir}/staticd
%{_sbindir}/vrrpd
%{_sbindir}/watchfrr
%{_sbindir}/watchfrr.sh
%{_sbindir}/zebra
%{_libdir}/lib%{name}.so.*
%{_libdir}/lib%{name}cares.so.*
%{_libdir}/lib%{name}ospfapiclient.so.*
%{_libdir}/%{name}/modules/*.so
%{_datadir}/yang/%{name}-*.yang
%{_datadir}/yang/ietf-routing-types.yang
%{_datadir}/yang/ietf-interfaces.yang
%{_datadir}/yang/ietf-bgp-types.yang
%{_datadir}/info/%{name}.info.gz
%{_mandir}/man1/*.1.gz
%{_mandir}/man8/*.8.gz

#-----------------------------------------------------------------------------
%pre
if [ "$1" = 1 ]; then
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{name}
  /usr/sbin/useradd 				\
	-r					\
	-c "FRR routing suite"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{name}				\
	-s /sbin/nologin			\
	-d %{_var}/log/%{name}			\
	%{name}
  fi

#-----------------------------------------------------------------------------
#after upgrade or remove
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  for element in %{composants} watchfrr
    do
    /sbin/chkconfig --del $element
    done
  /usr/sbin/userdel %{name}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post
for element in %{composants} watchfrr
  do
  /sbin/chkconfig --add $element
  %{_sysconfdir}/rc.d/init.d/$element condrestart > /dev/null 2>&1 || :
  done

#=============================================================================
%package		devel
Summary		:	Header and object files for frr development

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The frr-devel package contains the header and object files
neccessary for developing OSPF-API and frr applications.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}/*.h
%{_includedir}/%{name}/ospfd/*.h
%{_includedir}/%{name}/eigrpd/*.h
%{_includedir}/%{name}/bfdd/*.h
%{_includedir}/%{name}/ospfapi/*.h
%{_libdir}/lib*.so

#=============================================================================
%prep
%setup -q -n %{name}-%{name}-%{version}

#-----------------------------------------------------------------------------
#building application
%build

tar xf %{SOURCE1}

autoreconf -vif
PYTHON=/usr/bin/python3					\
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}/			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}/%{name}		\
        --sysconfdir=%{_sysconfdir}/%{name}		\
	--localstatedir=%{_localstatedir}/run/%{name}	\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--enable-doc					\
	--disable-static				\
	--disable-werror				\
	--with-moduledir=%{_libdir}/%{name}/modules	\
	--with-crypto=openssl 				\
	--enable-isisd=yes				\
	--enable-multipath=64				\
	--enable-vtysh=yes				\
	--enable-ospfclient=yes				\
	--enable-ospfapi=yes				\
	--enable-user=%{name}				\
	--enable-group=%{name}				\
	--enable-vty-group=%{name}			\
	--enable-babeld					\
	--enable-bgpd					\
	--enable-rtadv					\
	--enable-ripd					\
	--enable-ripngd					\
	--enable-staticd				\
	--enable-vrrpd					\
	--enable-watchfrr				\
	--enable-zebra					\

	
%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	%{_smp_mflags}					\

# Change frr-reload.py to use python3
sed -i							\
  -e '1c #!/usr/bin/python3'				\
  ./tools/frr-reload.py
  ./tools/generate_support_bundle.py

make -C doc all
#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make} DESTDIR=%{buildroot} install

#installing frr configuration directory directory
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{name}
%{__cp} -a 						\
	%{name}-ok_addon/conf/*				\
	%{buildroot}%{_sysconfdir}/%{name}

#installing frr scripts capablility
%{__mkdir_p} %{buildroot}%{_sysconfdir}/%{name}/scripts

cat > %{buildroot}%{_sysconfdir}/%{name}/scripts/README  << EOT
The behavior of FRR may be extended or customized using
its built-in scripting capabilities.

Some configuration commands accept the name of a Lua script
to call to perform some task or make some decision. These
scripts have their environments populated with some set of
inputs, and are expected to populate some set of output
variables, which are read by FRR after the script completes.
The names and expected contents of these scripts are documented
alongside the commands that support them.
EOT

#installing frr logging directory
%{__mkdir_p} %{buildroot}%{_var}/log/%{name}
#installing frr log rotation
%{__mkdir_p} %{buildroot}%{_sysconfdir}/logrotate.d
%{__cp} 						\
	%{name}-ok_addon/logrotate			\
	%{buildroot}%{_sysconfdir}/logrotate.d/%{name}

#installing frr starting/stopping script
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
for element in %{composants} watchfrr
  do
  %{__cp} 						\
	%{name}-ok_addon/$element			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d
  done
	
#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
